local GTex = {"Geronimo_HealthHud", "Geronimo_HealthHudBG", "Geronimo_ManaHud","Geronimo_ManaHudBG", "Geronimo_HealthHud_Text", "Geronimo_ManaHud_Text","Geronimo_HealthHud_R", "Geronimo_HealthHudBG_R", "Geronimo_ManaHud_R","Geronimo_ManaHudBG_R", "Geronimo_HealthHud_Text_R", "Geronimo_ManaHud_Text_R", "Geronimo_COMBO_01", "Geronimo_COMBO_02", "Geronimo_COMBO_03", "Geronimo_COMBO_04", "Geronimo_COMBO_05"};

local function GeronimoSetHeight(self,p,mh,tmh)
	local h = (tmh * p) + (mh - tmh);
	self:SetHeight(h);
	self:SetTexCoord(0, 1, 1- ((tmh * p + (mh - tmh)) / mh), 1);
end



function GeronimoHUD_OnLoad1()
	this:RegisterEvent("PLAYER_ENTERING_WORLD");
	this:RegisterEvent("UNIT_HEALTH");
	this:RegisterEvent("UNIT_MAXHEALTH");
	this:RegisterEvent("PLAYER_ENTER_COMBAT");
	this:RegisterEvent("PLAYER_LEAVE_COMBAT");
	this:RegisterEvent("PLAYER_REGEN_ENABLED");
	this:RegisterEvent("PLAYER_REGEN_DISABLED");
	this:RegisterEvent("UNIT_MANA");
	this:RegisterEvent("UNIT_RAGE");
	this:RegisterEvent("UNIT_FOCUS");
	this:RegisterEvent("UNIT_ENERGY");
end

function GeronimoHUD_OnLoad2()
	this:RegisterEvent("UNIT_HEALTH");
	this:RegisterEvent("UNIT_MAXHEALTH");
	this:RegisterEvent("PLAYER_ENTER_COMBAT");
	this:RegisterEvent("PLAYER_LEAVE_COMBAT");
	this:RegisterEvent("PLAYER_REGEN_ENABLED");
	this:RegisterEvent("PLAYER_REGEN_DISABLED");
	this:RegisterEvent("UNIT_MANA");
	this:RegisterEvent("UNIT_RAGE");
	this:RegisterEvent("UNIT_FOCUS");
	this:RegisterEvent("UNIT_ENERGY");
	this:RegisterEvent("PLAYER_TARGET_CHANGED");
	this:RegisterEvent("PLAYER_COMBO_POINTS");
end

function GeronimoHUD_OnLoad()
	local GTexture = {getglobal(GTex[1]), getglobal(GTex[2]), getglobal(GTex[3]), getglobal(GTex[4]), getglobal(GTex[5]), getglobal(GTex[6]), getglobal(GTex[7]), getglobal(GTex[8]), getglobal(GTex[9]), getglobal(GTex[10]), getglobal(GTex[11]), getglobal(GTex[12]), getglobal(GTex[13]), getglobal(GTex[14]), getglobal(GTex[15]), getglobal(GTex[16]), getglobal(GTex[17])};
	local i;
	this:RegisterEvent("PLAYER_ENTER_COMBAT");
	this:RegisterEvent("PLAYER_LEAVE_COMBAT");
	this:RegisterEvent("PLAYER_REGEN_ENABLED");
	this:RegisterEvent("PLAYER_REGEN_DISABLED");
	this:RegisterEvent("UNIT_HEALTH");
	this:RegisterEvent("UNIT_MANA");
	this:RegisterEvent("UNIT_RAGE");
	this:RegisterEvent("UNIT_FOCUS");
	this:RegisterEvent("UNIT_ENERGY");
	this:RegisterEvent("PLAYER_TARGET_CHANGED");
	
	GTexture[1]:SetAlpha(.3);
	GTexture[1]:SetVertexColor(1,1,0);
	GTexture[2]:SetAlpha(.1);
	GTexture[2]:SetVertexColor(.5,0,0);
	GTexture[3]:SetAlpha(.3);
	GTexture[3]:SetVertexColor(.3, .6, 1);
	GTexture[4]:SetAlpha(.1);
	GTexture[4]:SetVertexColor(.2, .1, .3);
	GTexture[5]:SetAlpha(.7);
	GTexture[6]:SetText(UnitMana("player"));
	GTexture[6]:SetAlpha(.7);
	GTexture[7]:SetAlpha(.3);
	GTexture[7]:SetVertexColor(1,1,0);
	GeronimoSetHeight(GTexture[7],0,256,256);
	GTexture[8]:SetAlpha(.1);
	GTexture[8]:SetVertexColor(.5,0,0);
	GTexture[9]:SetAlpha(.3);
	GTexture[9]:SetVertexColor(.3, .6, 1);
	GeronimoSetHeight(GTexture[9],0,256,212);
	GTexture[10]:SetAlpha(.1);
	GTexture[10]:SetVertexColor(.2, .1, .3);
	GTexture[11]:SetText("");
	GTexture[11]:SetAlpha(.7);
	GTexture[12]:SetText("");
	GTexture[12]:SetAlpha(.7);
	for i=13,17do
		GTexture[i]:SetAlpha(0);
		GTexture[i]:SetVertexColor(1, .5, .3);
	end
end

function Geronimo_PlayerHealth()
	local pmh = UnitHealthMax("player");
	local pch = UnitHealth("player");
	local p=pch/pmh;
	GeronimoSetHeight(Geronimo_HealthHud,p,256,256);
	Geronimo_HealthHud_Text:SetText(pch.."\n/"..pmh);
end

function Geronimo_PlayerMana()
	local m=UnitMana("player")/UnitManaMax("player");
	GeronimoSetHeight(Geronimo_ManaHud,m,256,212);
	Geronimo_ManaHud_Text:SetText(UnitMana("player"));
end

function Geronimo_TargetHealth()
	local uh = UnitHealth('target');
	if uh == nil then uh=0; end
	local uhm = UnitHealthMax('target');
	local p=uh/100;
	local tmh,tch;
	local myTxt;
	GeronimoSetHeight(Geronimo_HealthHud_R,p,256,256);
	if UnitIsDeadOrGhost("target") then
			myTxt = "Dead";
	elseif ((UnitInParty("target") or UnitIsUnit("target","pet"))) and uhm~=100 then
		myTxt = uh.."\n/"..uhm;
	else
		local mobName = UnitName('target');
		
		
		if mobName == nil then
			myTxt="";
		else
			
			
			GeronimoSetHeight(Geronimo_HealthHud_R,p,256,256);
		
			if MobHealthFrame then
				if (UnitInParty("target") or UnitIsUnit("target","pet")) then
					tch = uh
				else
					tch = Geronimo_MobHealth_GetTargetCurHP();
				end
				tmh = Geronimo_MobHealth_GetTargetMaxHP();
				
			else
				tmh = uhm;
				tch = uh;
			end 

			if tch == 0 then
				
				myTxt = "";
			elseif tch==uh and tmh==uhm then
				myTxt = uh.."%";
			else
				myTxt = tch.."\n/"..tmh;
			end
			-- message (myTxt);
		end
		
	end
	
	Geronimo_HealthHud_Text_R:SetText(myTxt);
end

function Geronimo_TargetMana()
	local tcm=UnitMana("target");
	if tcm == nil then tcm = 0; end
	p=tcm/UnitManaMax("target");
	GeronimoSetHeight(Geronimo_ManaHud_R,p,256,212);
	if tcm == 0 then tcm = nil; end
	Geronimo_ManaHud_Text_R:SetText(tcm);
end


function getonimo_show_combo()
	local gc = GetComboPoints();
	if gc > 0 then
		Geronimo_COMBO_01:SetAlpha(.8);
	else
		Geronimo_COMBO_01:SetAlpha(0);
	end
	if gc>0 and gc<=1 then
		Geronimo_COMBO_02:SetAlpha(.3);
	elseif gc>1 then
		Geronimo_COMBO_02:SetAlpha(.8);
	else
		Geronimo_COMBO_02:SetAlpha(.0);
	end
	if gc>0 and gc<=2 then
		Geronimo_COMBO_03:SetAlpha(.3);
	elseif gc>2 then
		Geronimo_COMBO_03:SetAlpha(.8);
	else
		Geronimo_COMBO_03:SetAlpha(.0);
	end
	if gc>0 and gc<=3 then
		Geronimo_COMBO_04:SetAlpha(.3);
	elseif gc>3 then
		Geronimo_COMBO_04:SetAlpha(.8);
	else
		Geronimo_COMBO_04:SetAlpha(.0);
	end
	if gc>0 and gc<=4 then
		Geronimo_COMBO_05:SetAlpha(.3);
	elseif gc>4 then
		Geronimo_COMBO_05:SetAlpha(.8);
	else
		Geronimo_COMBO_05:SetAlpha(.0);
	end
end

function  Geronimo_MobHealth_PPP( index )
  if  MobHealth_PPP  then
    return MobHealth_PPP( index );
  else
	if( index and MobHealthDB[index] ) then
		local s, e, pts, pct = string.find(MobHealthDB[index], "^(%d+)/(%d+)$");
		if( pts and pct ) then
			pts = pts + 0;
			pct = pct + 0;
			if( pct ~= 0 ) then
				return pts / pct;
			end
		end
	end
	return 0;
  end
end  -- of My_MobHealth_PPP

function Geronimo_MobHealth_GetTargetCurHP()
  if  MobHealth_GetTargetCurHP  then
	if MobHealth_GetTargetCurHP() then
		return MobHealth_GetTargetCurHP();
	else
		return UnitHealth("target");
	end
  else
    local name  = UnitName("target");
    local level = UnitLevel("target");
    local healthPercent = UnitHealth("target");
    if  name  and  level  and  healthPercent  then
      local index = name..":"..level;
      local ppp = Geronimo_MobHealth_PPP( index );
      return math.floor( healthPercent * ppp + 0.5);
    end
  end
  return 0;
end  -- of My_MobHealth_GetTargetCurHP()

function Geronimo_MobHealth_GetTargetMaxHP()
  if  MobHealth_GetTargetMaxHP  then
	if MobHealth_GetTargetMaxHP() then
		return MobHealth_GetTargetMaxHP();
	else
		return 100;
	end
  else
    local name  = UnitName("target");
    local level = UnitLevel("target");
    if  name  and  level  then
      local index = name..":"..level;
      local ppp = Geronimo_MobHealth_PPP( index );
      return math.floor( 100 * ppp + 0.5);
    end
  end
  return 0;
end  -- of My_MobHealth_GetTargetMaxHP()